<script setup lang="ts">
import { usePosStore } from '@/stores/pos'
import { useProductStore } from '@/stores/product'
import { useReceiptStore } from '@/stores/receipt'
import { ref } from 'vue'
import { getImageUrl, type Product } from '@/types/Product'

const posStore = usePosStore()
const receiptStore = useReceiptStore()
const productStore = useProductStore()
let categorycolor = ref(2)
let sweet = 0
const selectedSweetness = ref(2)
function addProductToReceipt() {
  console.log(productStore.product)
  if (productStore.product) {
    receiptStore.addReceiptItem(productStore.product)
    posStore.productCard = false
    productStore.clear()
  }
}
function checkCategory() {
  if (categorycolor.value !== 0) {
    addProductToReceipt()
  } else {
    alert('change category')
  }
}
function changCategory(category: number) {
  if (category === 1 && productStore.product) {
    productStore.changCategory(1, productStore.product)
    categorycolor.value = 1
  } else if (category === 2 && productStore.product) {
    productStore.changCategory(2, productStore.product)
    categorycolor.value = 2
  } else if (category === 3 && productStore.product) {
    productStore.changCategory(3, productStore.product)
    categorycolor.value = 3
  }
}

function addSweet(sweet: number) {
  if (productStore.product) productStore.addSweet(sweet, productStore.product)
}

const tickLabels = {
  0: '0',
  1: '50',
  2: '100',
  3: '150'
}
function handleSliderChange() {
  console.log('ค่าใหม่ที่เลือก:', selectedSweetness)
  if (selectedSweetness.value === 0) {
    sweet = 0
  } else if (selectedSweetness.value === 1) {
    sweet = 50
  } else if (selectedSweetness.value === 2) {
    sweet = 100
  } else {
    sweet = 150
  }
  addSweet(sweet)
}
</script>

<template>
  <v-dialog v-model="posStore.productCard" width="550" height="400">
    <v-container style="background-color: #ffffff; font-family: 'Kanit'; padding: 5%" class="rounded-dialog">
      <h1>Product Detail</h1>
      <v-row col="12" style="padding-top: 5%">
        <v-col cols="3"><v-img :src="`http://localhost:3000/images/products/` + productStore.product!.image"
            width="200px"></v-img></v-col>
        <v-col></v-col>
        <v-col cols="8">
          <v-divider vertical></v-divider>
          <v-row>name : {{ productStore.product?.name }}</v-row>
          <v-row>type : {{ productStore.product?.category }}</v-row>
          <!-- <v-col cols="2">name : {{ productStore.product?.name }}</v-col>
          <v-col cols="2">type : {{ productStore.product?.category }}</v-col> -->
        </v-col>
      </v-row>
      <v-row col="12">
        <v-col cols="3">category :</v-col>
        <v-col cols="3">
          <v-btn rounded="xl" size="large" style="padding: 2" @click="changCategory(1)"
            :color="categorycolor === 1 ? '#442300' : 'white-darken-1'">Hot</v-btn>
        </v-col>
        <v-col cols="3"><v-btn rounded="xl" size="large" style="padding: 2" @click="changCategory(2)"
            :color="categorycolor === 2 ? '#442300' : 'white-darken-1'">Iced</v-btn></v-col>
        <v-col cols="3"><v-btn rounded="xl" size="large" style="padding: 2" @click="changCategory(3)"
            :color="categorycolor === 3 ? '#442300' : 'white-darken-1'">Blended</v-btn></v-col>
      </v-row>
      <v-row col="12">
        <v-col cols="3">sweet :</v-col>
        <v-col cols="9">
          <v-slider v-model="selectedSweetness" :max="3" :ticks="tickLabels" show-ticks="always" step="1" tick-size="4"
            color="brown" @update:model-value="handleSliderChange()">
          </v-slider>
        </v-col>
        <v-col cols="6"></v-col>
      </v-row>
      <v-row>
        <v-col cols="6"><v-btn block rounded="xl" size="large" icon="mdi-delete" @click="posStore.productCard = false"
            color="red">
          </v-btn></v-col>
        <v-col cols="6"><v-btn block rounded="xl" size="large" icon="mdi-checkbox-marked-circle"
            @click="checkCategory()" color="green">
          </v-btn>
        </v-col>
      </v-row>
    </v-container>
  </v-dialog>
</template>

<style scoped>
.rounded-dialog {
  border-radius: 10px;
}
</style>
